#ifndef CELLFIELD_H
#define CELLFIELD_H

#include "Cell.h"
#include "ScalarField.h"

typedef struct {
	ScalarField const*	scalarField;
	Cell*				cells;
} CellField;

void init_CellField( CellField* self, ScalarField const* scalarField );
void destroy_CellField( CellField* self );
uint16_t getNumberOfCells_CellField( CellField const* self );

typedef struct {
	CellField*	cellField;
	Cell*		currentCell;
	uint16_t	currentIndex;
} CellFieldIterator;

CellFieldIterator createIterator_CellField( CellField* self );
void init_CellFieldIterator( CellFieldIterator* self, CellField* cellField );
void destroy_CellFieldIterator( CellFieldIterator* self );
Cell* dereference_CellFieldIterator( CellFieldIterator* self );
bool next_CellFieldIterator( CellFieldIterator* self );

#endif	/* CELLFIELD_H */
