#include "CellField.h"
#include <malloc.h>

inline void init_CellField( CellField* self, ScalarField const* scalarField ) {
	self->scalarField = scalarField;
	self->cells = malloc( sizeof( *self->cells ) * getNumberOfCells_CellField( self ) );

	Cell* cell = self->cells;
	for( uint16_t k=0; k<getDepth_ScalarField( scalarField ) - 1; ++k ) {
		for( uint16_t j=0; j<getHeight_ScalarField( scalarField ) - 1; ++j ) {
			for( uint16_t i=0; i<getWidth_ScalarField( scalarField ) - 1; ++i ) {
				init_Cell( cell, scalarField, i, j, k );
				++cell;
			}
		}
	}
}

inline void destroy_CellField( CellField* self ) {
	free( self->cells );
}

inline uint16_t getNumberOfCells_CellField( CellField const* self ) {
	return (getWidth_ScalarField( self->scalarField ) - 1)
		* (getHeight_ScalarField( self->scalarField ) - 1)
		* (getDepth_ScalarField( self->scalarField ) - 1);
}

inline CellFieldIterator createIterator_CellField( CellField* self ) {
	CellFieldIterator iterator;
	init_CellFieldIterator( &iterator, self );

	return iterator;
}

inline void init_CellFieldIterator( CellFieldIterator* self, CellField* cellField ) {
	self->cellField = cellField;
	self->currentCell = cellField->cells;
	self->currentIndex = 0;
}

inline void destroy_CellFieldIterator( CellFieldIterator* self ) {
	if( self ) {}
}

Cell* dereference_CellFieldIterator( CellFieldIterator* self ) {
	return self->currentCell;
}

bool next_CellFieldIterator( CellFieldIterator* self ) {
	if( self->currentIndex < getNumberOfCells_CellField( self->cellField ) - 1 ) {
		++self->currentIndex;
		++self->currentCell;

		return true;
	} else {
		return false;
	}
}
