#ifndef DLTRANS_H
#define DLTRANS_H

#include <containers/vec_.h>
#include <math/vector.h>
#include <sys/dlist.h>
#include <sys/nativedl.h>
#include <sys/surface.h>
#include <texture.h>
#include <types.h>

typedef struct {
	Vec				rspMatrices;
	Vec				vtxBuffer;
	uint8_t			vtxFormat;
	void const*		vtxSource;
	float			scale;
	Surface			surfColor;
	Surface			surfZ;
	Vector4f		clearColor;
	float			clearZVal;
	Texture const*	tex;
	Material		material;
} DLTrans;

void init_DLTrans( DLTrans* dltrans );
void destroy_DLTrans( DLTrans* dltrans );
void process_DLTrans( DLTrans* dltrans, DList const* dl_in, NativeDL* dl_out );

#endif	/* DLTRANS_H */

