#ifndef MATERIAL_H
#define MATERIAL_H

#include <math/vector.h>
#include "texture.h"

#define TEXTURE_ID_NONE	0xFFFF

typedef enum {
	TEXTUREMAPPING_CONST,
	TEXTUREMAPPING_ENV
} TextureMapping;

typedef enum {
	TEXTURECOMBINE_DECAL,
	TEXTURECOMBINE_ALPHA
} TextureCombine;

typedef struct {
	Vector4f		color;
	TextureMapping	tmapping;
	TextureCombine	tcombine;
	uint16_t		tex_id;
} Material;

#define MATERIAL_INIT( col, tm, texture ) \
{ .color = col, .tmapping = tm, .tcombine = TEXTURECOMBINE_DECAL, .tex_id = texture }

void clone_Material( Material const* self, Material* clone );
void setColor_Material( Material* self, float r, float g, float b, float a );
void setTextureCombine_Material( Material* self, TextureCombine );
Vector4f* getColor_Material( Material* self );
uint16_t getTextureId_Material( Material const* self );
TextureMapping getTextureMapping_Material( Material const* self );
TextureCombine getTextureCombine_Material( Material const* self );

#endif	/* MATERIAL_H */
