#ifndef MESH_H
#define MESH_H

#include <containers/vec_.h>
#include <layer.h>
#include <material.h>
#include <texture.h>

#define OWN

typedef struct {
	Vec			layers;		// Vec(Layer)
	float		opacity;
} Mesh;

/* interface */
void init_Mesh( Mesh* self );
void destroy_Mesh( Mesh* mesh );
void reset_Mesh( Mesh* mesh );
void setOpacity_Mesh( Mesh* mesh, float opacity );
float getOpacity_Mesh( Mesh const* mesh );
void addLayer_Mesh( Mesh* mesh, OWN Layer* layer );
Vec const* getLayersConst_Mesh( Mesh const* self );

#endif	/* MESH_H */
