#ifndef SYS_H
#define SYS_H

#include <types.h>
#include "dlist.h"
#include "gfxdevice.h"
#include "surface.h"
#include "time.h"

#define	BUFFER_W	320
#define	BUFFER_H	240

typedef void (*handler_f)( void* sys_arg, void* user_arg );

typedef enum {
	HANDLER_VBI,
	HANDLER_CONTROLLER
} HandlerType;

int	init_Sys( void );
void raiseError_Sys( void );
void registerHandler_Sys( HandlerType type, handler_f handler, void* user_arg );
void* getHiMem_Sys( void );
Time getTime_Sys( void );
void setAudioSource_Sys( void const* src );
void setAudioFrequency_Sys( uint32_t frequency );
void performDMA_Sys( void* dest, void const* src, size_t size );
GfxDevice* getGfxDevice_Sys( void );

#endif

