#include <heap.h>
#include <malloc.h>

#define ELEMENT_NONE	(0)
#define ELEMENT_SOME	(1)

void init_Heap( Heap* self, size_t el_size, size_t num_el ) {
	self->el_size = el_size;
	self->num_el = num_el;
	size_t data_size = (sizeof(uintmax_t) + el_size) * num_el;
	self->data = malloc( data_size );
	self->end = (void*)((uintptr_t)self->data + data_size);
}

void* alloc_Heap( Heap* self ) {
	uintptr_t ptr = (uintptr_t)self->data;
	while( (void*)ptr < self->end ) {
		if( ELEMENT_NONE == *(uintmax_t*)ptr ) {
			*(uintmax_t*)ptr = ELEMENT_SOME;
			return (void*)(ptr + sizeof(uintmax_t));
		}
		ptr += sizeof(uintmax_t) + self->el_size;
	}

	return NULL;
}

void free_Heap( Heap* self, void* element ) {
	if( self ) {}
	uintptr_t* ptr = element;
	*(uintmax_t*)(ptr - sizeof(uintmax_t)) = ELEMENT_NONE;
}
