#include <math/math.h>

inline bool log2_has_frac(uint32_t val) {
	uint8_t bits = 0;
	while(val) {
		if( (val & 0x1) && (++bits >= 2) ) {
			return true;
		}
		val >>= 1;
	}

	return false;
}

uint8_t log2uint(uint32_t val) {
	uint8_t res=0;
	while(val) {
		val >>= 1;
		res++;
	}
	return res-1;
}

inline float fabsf(float x) {
	return x>=0 ? x:-x;
}

void transformVector_Math( Vector3f* out, Vector3f* vec, Matrix* mtx ) {
	out->x = MATRIX_GET(*mtx, 0, 0)*vec->x + MATRIX_GET(*mtx, 1, 0)*vec->y + MATRIX_GET(*mtx, 2, 0)*vec->z + MATRIX_GET(*mtx, 3, 0);
	out->y = MATRIX_GET(*mtx, 0, 1)*vec->x + MATRIX_GET(*mtx, 1, 1)*vec->y + MATRIX_GET(*mtx, 2, 1)*vec->z + MATRIX_GET(*mtx, 3, 1);
	out->z = MATRIX_GET(*mtx, 0, 2)*vec->x + MATRIX_GET(*mtx, 1, 2)*vec->y + MATRIX_GET(*mtx, 2, 2)*vec->z + MATRIX_GET(*mtx, 3, 2);
}

