#include <abort.h>
#include "texture.h"

void copy_Texture( Texture* self, Texture const* source ) {
	*self = *source;
}

void destroy_Texture( Texture* self ) {
	if( self ) {}
}

inline uint32_t getPixelCount_Texture( Texture const* self ) {
	return self->width * self->height;
}

inline uint16_t getWidth_Texture( Texture const* self ) {
	return self->width;
}

inline uint16_t getHeight_Texture( Texture const* self ) {
	return self->height;
}

inline uint8_t getBytesPerPixel_Texture( Texture const* self ) {
	switch( getFormat_Texture( self ) ) {
		case TEXTURE_FMT_RGBA16: {
			return 2;
		}
		case TEXTURE_FMT_RGBA32: {
			return 4;
		}
		default: {
			abort();
			return -1;
		}
	}
}

inline TextureFormat getFormat_Texture( Texture const* self ) {
	return self->fmt;
}

inline void* getPixels_Texture( Texture* self ) {
	return self->pixels;
}

inline void const* getPixelsConst_Texture( Texture const* self ) {
	return self->pixels;
}

inline void const* getPaletteConst_Texture( Texture const* self ) {
	return self->palette;
}

